//+------------------------------------------------------------------+
//|                                      Previous Highs And Lows.mq4 |
//|                                   Copyright  2005, Jason Rivera |
//|                                      http://www.jasonerivera.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Jason Rivera, copywriter-OZ"
#property link      "http://www.jasonerivera.com, finansovyj-dozor@narod.ru"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Yellow
double H=0;
double L=0;
extern int shift_time = 0;
//extern double    H     = -7.5;      //        
//extern double    L     = 1.7;      //  

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
int     fontsize1=8;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {   
//---- indicators
   SetIndexLabel(0,"Previous High");
   SetIndexLabel(1,"Previous Low");
   SetIndexStyle(0,DRAW_SECTION, STYLE_SOLID, 1);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_SECTION, STYLE_SOLID, 1);
   SetIndexBuffer(1,ExtMapBuffer2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   ObjectDelete("Prev-High");
   ObjectDelete("Prev-Low");
   ObjectDelete("l1");
   ObjectDelete("l2");

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   int pos = Bars-shift_time-1;
   int m = 0;
   int d = 0;
   int y = 0;
   string dt = "";
   datetime some_time = 0;
   int shift = 0;
   int tc = 0;
//----    
   if(Bars - counted_bars == 1) return(0);
   
   if( Bars < shift_time + 3 ) return(0);
   
   if (Period() < 1440)
   {
      tc = 1440;
   }else
   {
      switch (Period())
      {
      case 1440: 
         tc = 10080; 
         break;
      case 10080: 
         tc = 43200; 
         break;
      case 43200: 
         tc = 518400; 
         break;
      }
   }
   if (DayOfWeek()==0)  shift_time=3;// 3? //Print("shift time is ", shift_time); 
   while(pos>=0)
   {
      m=TimeMonth(Time[pos]);
      d=TimeDay(Time[pos]);
      y=TimeYear(Time[pos]);
      dt = y + "." + m + "." + d + " 00:00";
      some_time = StrToTime(dt);
      
      //find the proper shift of the Daily bar having the same date as this timeframe's bar with the current shift
      shift = iBarShift(NULL,tc,some_time); 
      
      H = iHigh(NULL,tc,shift+shift_time);
      L = iLow(NULL,tc,shift+shift_time);
           
      ExtMapBuffer1[pos] = H;
      ExtMapBuffer2[pos] = L; 
      
      {
   ObjectCreate("l1", OBJ_TEXT, 0, 0, 0);//   OBJ_TEXT  chart_window  separate_window, 
   ObjectSet("l1", OBJPROP_PRICE1, H);//
   ObjectSetText("l1", DoubleToStr(H, Digits), fontsize1, "Arial", Magenta );// 
   ObjectMove("l1", 0,Time[0], ExtMapBuffer1[pos]);
      }   
      {
   ObjectCreate("l2", OBJ_TEXT, 0, 0, 0);//
   ObjectSet("l2", OBJPROP_PRICE1, L);//-(Ask-Bid)*Dn/Point);//    +(Ask-Bid)*Up20
   ObjectSetText("l2", DoubleToStr(L, Digits), fontsize1, "Arial", Magenta );// 
   ObjectMove("l2", 0,Time[0], ExtMapBuffer2[pos]);
      }   

      
      if(pos==0) CreateLabels();
      
      pos--;
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
///*
void CreateLabels()
{
   if(ObjectFind("Prev-High")==-1)
   {
      ObjectCreate("Prev-High", OBJ_TEXT, 0, CurTime(), H);
      ObjectSetText("Prev-High", "         Hi", 12, "Verdana", Aqua);
   }
   else 
   {
      ObjectMove("Prev-High", 0, CurTime(), H);
   }      
      
   if(ObjectFind("Prev-Low")==-1)
   {
      ObjectCreate("Prev-Low", OBJ_TEXT, 0, CurTime(), L);
      ObjectSetText("Prev-Low", "         Lo", 12, "Verdana", Yellow);
   }
   else 
   {
      ObjectMove("Prev-Low", 0, CurTime(), L); 
   }
 
//*/ 
     
   return(0);

}